# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2017_09_01_preview
  module Models
    #
    # Parameters supplied to the Create operation.
    #
    class FileServerCreateParameters

      include MsRestAzure

      # @return [String] The region in which to create the File Server.
      attr_accessor :location

      # @return [Hash{String => String}] The user specified tags associated
      # with the File Server.
      attr_accessor :tags

      # @return [String] The size of the virtual machine of the file server.
      # For information about available VM sizes for fileservers from the
      # Virtual Machines Marketplace, see Sizes for Virtual Machines (Linux).
      attr_accessor :vm_size

      # @return [SshConfiguration] SSH settings for the file server.
      attr_accessor :ssh_configuration

      # @return [DataDisks] Settings for the data disk which would be created
      # for the file server.
      attr_accessor :data_disks

      # @return [ResourceId] Specifies the identifier of the subnet.
      attr_accessor :subnet


      #
      # Mapper for FileServerCreateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FileServerCreateParameters',
          type: {
            name: 'Composite',
            class_name: 'FileServerCreateParameters',
            model_properties: {
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              vm_size: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.vmSize',
                type: {
                  name: 'String'
                }
              },
              ssh_configuration: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.sshConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'SshConfiguration'
                }
              },
              data_disks: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.dataDisks',
                type: {
                  name: 'Composite',
                  class_name: 'DataDisks'
                }
              },
              subnet: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.subnet',
                type: {
                  name: 'Composite',
                  class_name: 'ResourceId'
                }
              }
            }
          }
        }
      end
    end
  end
end
