# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_03_01
  module Models
    #
    # Provides required information, for the service to be able to mount Azure
    # Blob Storage container on the cluster nodes.
    #
    class AzureBlobFileSystemReference

      include MsRestAzure

      # @return [String] Name of the Azure Blob Storage account.
      attr_accessor :account_name

      # @return [String] Name of the Azure Blob Storage container to mount on
      # the cluster.
      attr_accessor :container_name

      # @return [AzureStorageCredentialsInfo] Information of the Azure Blob
      # Storage account credentials.
      attr_accessor :credentials

      # @return [String] Specifies the relative path on the compute node where
      # the Azure Blob file system will be mounted. Note that all cluster level
      # blob file systems will be mounted under $AZ_BATCHAI_MOUNT_ROOT location
      # and all job level blob file systems will be mounted under
      # $AZ_BATCHAI_JOB_MOUNT_ROOT.
      attr_accessor :relative_mount_path

      # @return [String] Specifies the various mount options that can be used
      # to configure Blob file system.
      attr_accessor :mount_options


      #
      # Mapper for AzureBlobFileSystemReference class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureBlobFileSystemReference',
          type: {
            name: 'Composite',
            class_name: 'AzureBlobFileSystemReference',
            model_properties: {
              account_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'accountName',
                type: {
                  name: 'String'
                }
              },
              container_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'containerName',
                type: {
                  name: 'String'
                }
              },
              credentials: {
                client_side_validation: true,
                required: true,
                serialized_name: 'credentials',
                type: {
                  name: 'Composite',
                  class_name: 'AzureStorageCredentialsInfo'
                }
              },
              relative_mount_path: {
                client_side_validation: true,
                required: true,
                serialized_name: 'relativeMountPath',
                type: {
                  name: 'String'
                }
              },
              mount_options: {
                client_side_validation: true,
                required: false,
                serialized_name: 'mountOptions',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
