# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_03_01
  module Models
    #
    # Output directory for the job.
    #
    class OutputDirectory

      include MsRestAzure

      # @return [String] The name for the output directory. The path of the
      # output directory will be available as a value of an environment
      # variable with AZ_BATCHAI_OUTPUT_<id> name, where <id> is the value of
      # id attribute.
      attr_accessor :id

      # @return [String] The prefix path where the output directory will be
      # created. NOTE: This is an absolute path to prefix. E.g.
      # $AZ_BATCHAI_MOUNT_ROOT/MyNFS/MyLogs. You can find the full path to the
      # output directory by combining pathPrefix, jobOutputDirectoryPathSegment
      # (reported by get job) and pathSuffix.
      attr_accessor :path_prefix

      # @return [String] The suffix path where the output directory will be
      # created. The suffix path where the output directory will be created.
      # E.g. models. You can find the full path to the output directory by
      # combining pathPrefix, jobOutputDirectoryPathSegment (reported by get
      # job) and pathSuffix.
      attr_accessor :path_suffix

      # @return [OutputType] An enumeration, which specifies the type of job
      # output directory. Default value is Custom. The possible values are
      # Model, Logs, Summary, and Custom. Users can use multiple enums for a
      # single directory. Eg. outPutType='Model,Logs, Summary'. Possible values
      # include: 'model', 'logs', 'summary', 'custom'. Default value: 'custom'
      # .
      attr_accessor :type

      # @return [Boolean] True to create new directory. Default is true. If
      # false, then the directory is not created and can be any directory path
      # that the user specifies. Default value: true .
      attr_accessor :create_new


      #
      # Mapper for OutputDirectory class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'OutputDirectory',
          type: {
            name: 'Composite',
            class_name: 'OutputDirectory',
            model_properties: {
              id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              path_prefix: {
                client_side_validation: true,
                required: true,
                serialized_name: 'pathPrefix',
                type: {
                  name: 'String'
                }
              },
              path_suffix: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pathSuffix',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'type',
                default_value: 'custom',
                type: {
                  name: 'String'
                }
              },
              create_new: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createNew',
                default_value: true,
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
