# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BatchAI::Mgmt::V2018_05_01
  module Models
    #
    # Node setup settings.
    #
    class NodeSetup

      include MsRestAzure

      # @return [SetupTask] Setup task. Setup task to run on cluster nodes when
      # nodes got created or rebooted. The setup task code needs to be
      # idempotent. Generally the setup task is used to download static data
      # that is required for all jobs that run on the cluster VMs and/or to
      # download/install software.
      attr_accessor :setup_task

      # @return [MountVolumes] Mount volumes. Mount volumes to be available to
      # setup task and all jobs executing on the cluster. The volumes will be
      # mounted at location specified by $AZ_BATCHAI_MOUNT_ROOT environment
      # variable.
      attr_accessor :mount_volumes

      # @return [PerformanceCountersSettings] Performance counters settings.
      # Settings for performance counters collecting and uploading.
      attr_accessor :performance_counters_settings


      #
      # Mapper for NodeSetup class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'NodeSetup',
          type: {
            name: 'Composite',
            class_name: 'NodeSetup',
            model_properties: {
              setup_task: {
                client_side_validation: true,
                required: false,
                serialized_name: 'setupTask',
                type: {
                  name: 'Composite',
                  class_name: 'SetupTask'
                }
              },
              mount_volumes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'mountVolumes',
                type: {
                  name: 'Composite',
                  class_name: 'MountVolumes'
                }
              },
              performance_counters_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'performanceCountersSettings',
                type: {
                  name: 'Composite',
                  class_name: 'PerformanceCountersSettings'
                }
              }
            }
          }
        }
      end
    end
  end
end
